﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Reactive.Linq;
using System.Reactive.Concurrency;

namespace RxVSMSampleWpfSimpleEvent
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

          var mouseMovements =
         Observable.FromEvent<MouseEventArgs>(
           ev =>
           {
               this.MouseMove += (s, e) => ev(e);
           },
           ev =>
           {
               this.MouseMove -= (s, e) => ev(e);
           });

          var mousePoints = from m in mouseMovements select m.GetPosition(this);
          mousePoints.ObserveOnDispatcher().Subscribe((pos) => mousePos.Content = pos.ToString());
        }
    }
}
